version: '3'
services:

  ###> OPENAPI ###
  swagger-editor:
    image: swaggerapi/swagger-editor
    ports:
      - "19000:8080"
    networks:
      - book-frontend
  swagger-ui:
    image: swaggerapi/swagger-ui
    volumes:
      - ./public/v1:/swagger
    environment:
      SWAGGER_JSON: /swagger/openapi.json
    ports:
      - "19010:8080"
    networks:
      - book-frontend
  ###< OPENAPI  ###

  ###> REDIS ###
  redis:
    image: redis:6-alpine
    ports:
      - "6379:6379"
    networks:
      - book-frontend
  ###< REDIS  ###

  ###> EX-BOOK-LIST-API ###
  book-list-db:
    image: postgres:14-alpine
    ports:
      - "45433:5432"
    volumes:
      - 'book-list-db-data:/var/lib/postgresql/data'
    environment:
      - POSTGRES_PASSWORD=2vQU45haQCnDS8sO
      - POSTGRES_USER=book-list
      - POSTGRES_DB=book-list
    networks:
      - book-frontend
  book-list:
    image: "registry.gitlab.com/mobica-workshops/examples/go/gorilla/book-list"
    command: ["serve", "--config", "/secrets/local.env.yaml", "-b", "0.0.0.0", "-p", "8080", "-m", "-w", "10", "-l"]
    ports:
      - "8882:8080"
    volumes:
      - ./secrets/book-list/docker.env.yaml:/secrets/local.env.yaml
    depends_on:
      - book-list-db
      - redis
    networks:
      - book-frontend
  ###< EX-BOOK-LIST-API ###

  ###> EX-BOOK-ADMIN-API ###
  # https://github.com/bitnami/bitnami-docker-mongodb/blob/master/README.md
  book-admin-db:
    image: "docker.io/bitnami/mongodb:4.4"
    ports:
      - "47018:27017"
    volumes:
      - 'book-admin-db-data:/bitnami/mongodb'
    environment:
      - MONGODB_ROOT_PASSWORD=vEoZs9tEk3jLqS76
      - MONGODB_USERNAME=book-admin
      - MONGODB_PASSWORD=2vQU45haQCnDS8sO
      - MONGODB_DATABASE=book-admin
    networks:
      - book-frontend
  book-admin:
    image: "registry.gitlab.com/mobica-workshops/examples/go/gorilla/book-admin:latest"
    command: ["serve", "--config", "/secrets/local.env.yaml", "-b", "0.0.0.0", "-p", "8080", "-l"]
    ports:
      - "8883:8080"
    volumes:
      - ./secrets/book-admin/docker.env.yaml:/secrets/local.env.yaml
    networks:
      - book-frontend
  ###< EX-BOOK-ADMIN-API ###

  ###> EX-BOOK-API-GATEWAY ###
  book-bff:
    image: "registry.gitlab.com/mobica-workshops/examples/go/gorilla/book-bff:latest"
    command: ["serve", "--config", "/secrets/local.env.yaml", "-b", "0.0.0.0", "-p", "8080", "-c"]  # cors
    ports:
      - "8881:8080"
    volumes:
      - ./secrets/book-bff/docker.env.yaml:/secrets/local.env.yaml
    networks:
      - book-frontend
  ###< EX-BOOK-API-GATEWAY ###

networks:
  book-frontend:
    driver: bridge

volumes:
  data-volume:
  book-list-db-data:
    driver: local
  book-admin-db-data:
    driver: local
